//
//  ViewController.swift
//  Stoppuhr
//
//  Created by Holger Hinzberg on 11.09.17.
//  Copyright © 2017 Holger Hinzberg. All rights reserved.
//

import UIKit

class ViewController: UIViewController
{
    @IBOutlet var stopuhrLabel: UILabel!
    
    // Ein Timer als Eigenschaft der Klasse
    var timer:Timer?
    // Startzeitpunkt der Stopuhr
    var startzeit:Date?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view,
        // typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    @IBAction func startButtonBeruehrt(_ sender: Any)
    {
        // Einen vorhandenen Timer anhalten
        self.timer?.invalidate()
        
        // Die aktuelle Uhrzeit als Startzeitpunkt ablegen
        self.startzeit = Date();
        
        // Einen Timer anlegen und konfigurieren mit einer Closure
        self.timer = Timer.scheduledTimer(withTimeInterval: 0.5, repeats: true)
        {
            timer in
            
            // Die Zeitspanne zwischen Startzeitpunkt und "Jetzt" berechnen
            let jetzt = Date()
            let interval:TimeInterval =  jetzt.timeIntervalSince(self.startzeit!)
            
            let zeitspanne = Int(interval)
            let sekunden = zeitspanne % 60
            let minuten = (zeitspanne / 60) % 60
            let stunden = (zeitspanne / 3600)
            
            // Die Zeitspanne als Zeichenkette ausgeben.
            let zeit = String(format: "%02d:%02d:%02d", stunden, minuten, sekunden)
            self.stopuhrLabel.text = zeit;
         }
        
        // Deb Timer ein Mal sofort ausführen
        self.timer?.fire()
    }
    
    @IBAction func stopButtonBeruehrt(_ sender: Any)
    {
        // Den Timer anhalten
        self.timer?.invalidate()
    }
}

