//
//  ViewController.swift
//  Maulwurf
//
//  Created by Holger Hinzberg on 23.10.17.
//  Copyright © 2017 Holger Hinzberg. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet var fortschrittsbalken: UIProgressView!
    @IBOutlet var verbleibendeSpielzeitLabel:UILabel!
    @IBOutlet var button1: UIButton!
    @IBOutlet var button2: UIButton!
    @IBOutlet var button3: UIButton!
    @IBOutlet var button4: UIButton!
    @IBOutlet var button5: UIButton!
    @IBOutlet var button6: UIButton!
    @IBOutlet var button7: UIButton!
    @IBOutlet var button8: UIButton!
    @IBOutlet var button9: UIButton!
    @IBOutlet var button10: UIButton!
    @IBOutlet var button11: UIButton!
    @IBOutlet var button12: UIButton!
    
    // Ein Zähler für die erfolgreichen Treffer
    var mauswurfZaehler:Int = 0
    // Die maximale Spielzeit, in Sekunden
    let maximaleSpielzeit: Int = 30
    // Die verstrichene Spielzeit, in Sekunden
    var verstricheneSpielzeit:Int = 0
    // Wie lange ist ein Maulwurf sichtbar, in Sekunden
    var sichbarkeitszeit: Int = 2
    // Zwei Timer für den Spielablauf
    var spielzeitTimer:Timer?
    var buttonzeitTimer:Timer?
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        self.verbleibendeSpielzeitLabel.text = ""
        
        let viewBreite:CGFloat = self.view.bounds.width
       
        let randAbstand:CGFloat = 16
        let buttonAbstand:CGFloat = 2
        let buttonBreite = (viewBreite - randAbstand * 2 - buttonAbstand * 2 ) / 3
        
        let buttonHoehe = buttonBreite
        
        let buttonGroesse
            = CGSize(width: buttonBreite, height: buttonHoehe)
        
        self.button1.bounds.size = buttonGroesse
        self.button2.bounds.size = buttonGroesse
        self.button3.bounds.size = buttonGroesse
        self.button4.bounds.size = buttonGroesse
        self.button5.bounds.size = buttonGroesse
        self.button6.bounds.size = buttonGroesse
        self.button7.bounds.size = buttonGroesse
        self.button8.bounds.size = buttonGroesse
        self.button9.bounds.size = buttonGroesse
        self.button10.bounds.size = buttonGroesse
        self.button11.bounds.size = buttonGroesse
        self.button12.bounds.size = buttonGroesse
        
        let abstandVonOben:CGFloat = 200
        
        // Die Spalten
        let xSpalte1:CGFloat = randAbstand
        let xSpalte2:CGFloat = randAbstand + buttonBreite + buttonAbstand
        let  xSpalte3:CGFloat = randAbstand + ((buttonBreite + buttonAbstand) * 2)
        
        // Die Zeilen
        let yZeile1:CGFloat  = abstandVonOben
        let yZeile2:CGFloat  = abstandVonOben + buttonHoehe + buttonAbstand
        let yZeile3:CGFloat  = abstandVonOben + ((buttonHoehe + buttonAbstand) * 2)
        let yZeile4:CGFloat  = abstandVonOben + ((buttonHoehe + buttonAbstand) * 3)
        
        // Die erste Reihe
        var origin = CGPoint(x: xSpalte1, y: yZeile1)
        self.button1.frame.origin = origin

        origin = CGPoint(x: xSpalte2, y: yZeile1)
        self.button2.frame.origin = origin
        
        origin = CGPoint(x: xSpalte3, y: yZeile1)
        self.button3.frame.origin = origin
        
        // Die zweite Reihe
        origin = CGPoint(x: xSpalte1, y: yZeile2)
        self.button4.frame.origin = origin
        
        origin = CGPoint(x: xSpalte2, y: yZeile2)
        self.button5.frame.origin = origin
        
        origin = CGPoint(x: xSpalte3, y: yZeile2)
        self.button6.frame.origin = origin
        
        // Die dritte Reihe
        origin = CGPoint(x: xSpalte1, y: yZeile3)
        self.button7.frame.origin = origin
        
        origin = CGPoint(x: xSpalte2, y: yZeile3)
        self.button8.frame.origin = origin
        
        origin = CGPoint(x: xSpalte3, y: yZeile3)
        self.button9.frame.origin = origin
        
        // Die vierte Reihe
        origin = CGPoint(x: xSpalte1, y: yZeile4)
        self.button10.frame.origin = origin
        
        origin = CGPoint(x: xSpalte2, y: yZeile4)
        self.button11.frame.origin = origin
        
        origin = CGPoint(x: xSpalte3, y: yZeile4)
        self.button12.frame.origin = origin
    }

    @IBAction func startButtonBeruehrt(_ sender: Any)
    {
        // Die Zähler zurücksetzen
        self.mauswurfZaehler = 0
        self.verstricheneSpielzeit = 0
        self.verbleibendeSpielzeitLabel.text = ""
        
        // Einen bestehenden Timer stoppen
        // und einen neuen Timer starten.
        self.spielzeitTimer?.invalidate()
        self.spielzeitTimer = Timer.scheduledTimer(withTimeInterval: 1, repeats: true)
        {
            timer in
            self.ticktack()
        }
        self.spielzeitTimer?.fire()
        
        // Der Timer um die Buttons ein und auszublenden
        self.buttonzeitTimer?.invalidate()
        self.buttonzeitTimer = Timer.scheduledTimer(withTimeInterval: TimeInterval(sichbarkeitszeit), repeats: true)
        {
            timer in
            self.zeigeMaulwurf()
        }
        self.buttonzeitTimer?.fire()
    }
    
    func ticktack()
    {
        // Den Fortschrittsbalken aktualisieren
        self.verstricheneSpielzeit += 1
        let fortschritt:Float = Float(self.verstricheneSpielzeit) /  Float(self.maximaleSpielzeit)
        self.fortschrittsbalken.progress = fortschritt
        
        self.verbleibendeSpielzeitLabel.text = "Noch \(self.maximaleSpielzeit - self.verstricheneSpielzeit) Sekunden"
        
        // Ist die Spielzeit abgelaufen
        if self.verstricheneSpielzeit == self.maximaleSpielzeit
        {
            // Die beiden Timer anhalten
            self.spielzeitTimer?.invalidate()
            self.buttonzeitTimer?.invalidate()
            
            // Einen UIAlertController konfigurieren
            let titel = "Die Zeit ist abgelaufen!"
            var text = ""
            
            if self.mauswurfZaehler == 0
            {
                text = "Du hast keinen Maulwurf erwischt."
            }
            else if self.mauswurfZaehler == 1
            {
                text = "Du hast einen Maulwurf erwischt."
            }
            else
            {
                text = "Du hast \(self.mauswurfZaehler) Maulwürfe erwischt."
            }
            
            let alert = UIAlertController.init(title: titel, message: text, preferredStyle: UIAlertControllerStyle.alert)
            
           // Eine Aktion / Button für den UIAlertController
            let okAktion = UIAlertAction(title: "OK", style: UIAlertActionStyle.default)
            {
                action in
                self.fortschrittsbalken.progress = 0
            }
            alert.addAction(okAktion)
            
            // Den UIAlertController anzeigen
            self.present(alert, animated: true)
        }
    }
    
    func zeigeMaulwurf()
    {
        // Alle Buttons werden unsichtbar
        self.button1.isHidden = true
        self.button2.isHidden = true
        self.button3.isHidden = true
        self.button4.isHidden = true
        self.button5.isHidden = true
        self.button6.isHidden = true
        self.button7.isHidden = true
        self.button8.isHidden = true
        self.button9.isHidden = true
        self.button10.isHidden = true
        self.button11.isHidden = true
        self.button12.isHidden = true
        
        // Eine Zufallszahl von 1 bis 12
        let zufallszahl = arc4random_uniform(12) + 1
        
        // Einen Button wieder sichtbar machen
        switch zufallszahl
        {
        case 1:
            self.button1.isHidden = false
        case 2:
            self.button2.isHidden = false
        case 3:
            self.button3.isHidden = false
        case 4:
            self.button4.isHidden = false
        case 5:
            self.button5.isHidden = false
        case 6:
            self.button6.isHidden = false
        case 7:
            self.button7.isHidden = false
        case 8:
            self.button8.isHidden = false
        case 9:
            self.button9.isHidden = false
        case 10:
            self.button10.isHidden = false
        case 11:
            self.button11.isHidden = false
        case 12:
            self.button12.isHidden = false
        default:
            break
        }
    }
    
    @IBAction func maulwurfButtonBeruehrt(_ sender: Any)
    {
        self.mauswurfZaehler += 1
        self.buttonzeitTimer?.fire()
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    override var shouldAutorotate: Bool
    {
        return true
    }
    
    override var supportedInterfaceOrientations: UIInterfaceOrientationMask
    {
        return UIInterfaceOrientationMask.portrait
    }
    
    override var prefersStatusBarHidden: Bool
    {
        return true
    }
}

