//
//  ViewController.swift
//  Lottozahlen
//
//  Created by Holger Hinzberg on 07.12.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import UIKit

class ViewController: UIViewController
{
    // Der Zufallszahlengenerator wird zu 
    // einer Eigenschaft der Klasse
    private var generator:Zufallszahlengenerator?
    
    // So viele Zufallszahlen sollen ausgelost werden
    private let anzahlDerZufallszahlen:Int = 10
    
    // Die Zufallszahlen sind zwischen 1 und dem
    // angegebenen Wert
    private let hoechsteZufallszahl:UInt32 = 49
    
    @IBOutlet var wert1Label:UILabel?
    @IBOutlet var wert2Label:UILabel?
    @IBOutlet var wert3Label:UILabel?
    @IBOutlet var wert4Label:UILabel?
    @IBOutlet var wert5Label:UILabel?
    @IBOutlet var wert6Label:UILabel?
    @IBOutlet var wert7Label:UILabel?
    @IBOutlet var wert8Label:UILabel?
    @IBOutlet var wert9Label:UILabel?
    @IBOutlet var wert10Label:UILabel?
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        // Do any additional setup after loading the 
        // view, typically from a nib.
        wert1Label?.text = ""
        wert2Label?.text = ""
        wert3Label?.text = ""
        wert4Label?.text = ""
        wert5Label?.text = ""
        wert6Label?.text = ""
        wert7Label?.text = ""
        wert8Label?.text = ""
        wert9Label?.text = ""
        wert10Label?.text = ""
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func lottoSpielenTasteBeruehrt()
    {
        // Prüfen, ob es eine Instanz gibt oder ein
        // ein Objekt erstellt werden muss
        if self.generator == nil
        {
            self.generator = Zufallszahlengenerator()
        }
        
        let zahlen = generator!.Generiere(anzahlDerWerte:
            self.anzahlDerZufallszahlen,
            hoechsterWert: self.hoechsteZufallszahl)
        
        let labels = [wert1Label, wert2Label, wert3Label,
                      wert4Label, wert5Label, wert6Label, wert7Label,
                      wert8Label, wert9Label, wert10Label]
        
        for index in 0 ..< labels.count
        {
            if zahlen.count > index
            {
                labels[index]?.text = "\(zahlen[index])"
            }
            else
            {
                labels[index]?.text = ""
            }
        }   
    }
}

